# This plugin should be reloaded in development mode.
if RAILS_ENV == "development"
  ActiveSupport::Dependencies.load_once_paths.reject!{|x| x =~ /^#{Regexp.escape(File.dirname(__FILE__))}/}
end

require "redmine"
require "iconv"
require "rfpdf/chinese"
require "rfpdf/fpdf"
require "export_report"
require "dispatcher"
Dispatcher.to_prepare do 
  begin
    require_dependency "application"
  rescue LoadError
    require_dependency "application_controller"
  end
end

RAILS_DEFAULT_LOGGER.info "Advanced report plugin for RedMine"

Redmine::Plugin.register :advanced_report do
  name "Advanced report plugin"
  url "http://ociotec.com/redmine/projects/show/advanced-report"
  author "Emilio González Montaña"
  author_url "http://ociotec.com"
  description "This is a plugin for Redmine that is used to show advanced report page"
  version "0.0.4"
  requires_redmine :version_or_higher => "0.9.0"

  settings :default => {"project_list_size" => "5", 
                        "time_log_graph_week_count" => "8",
                        "time_log_graph_width" => "800",
                        "time_log_graph_height" => "500",
                        "burn_down_graph_week_count" => "16",
                        "burn_down_graph_width" => "800",
                        "burn_down_graph_height" => "400"}, 
           :partial => "settings/advanced_report_settings"

  permission :see_advanced_report, { }, :require => :member

  menu(:top_menu,
       :advanced_report,
       {:controller => :advanced_report, :action => :index},
       :caption => :advanced_report_title,
       :if => Proc.new {
         User.current.allowed_to?(:see_advanced_report, nil, :global => true) ||
         User.current.allowed_to?(:view_time_entries, nil, :global => true) ||
         User.current.admin?
       })
end
